"""Integration tests for the dirty_image module."""

from dataclasses import replace
from typing import Callable

import dask.array as da
import numpy as np
import pytest
from ska_sdp_exec_swiftly import SubgridConfig

from ska_sdp_distributed_self_cal_prototype.data_managers.visibility_bin import VisibilityBin
from ska_sdp_distributed_self_cal_prototype.processing_tasks._gridding_utils import _determine_w_step
from ska_sdp_distributed_self_cal_prototype.processing_tasks.binning import _compute_stokes_i
from ska_sdp_distributed_self_cal_prototype.processing_tasks.gridding import Gridder
from ska_sdp_distributed_self_cal_prototype.workflow.pipeline_config import PipelineConfig
from ska_sdp_distributed_self_cal_prototype.workflow.tasks import (
    bin_data,
    grid_visibilities,
    predict_residual_visibilities,
    setup_pipeline,
)


def test_gridding_task(
    xarray_dataset_single_time_frequency_two_polarizations, pipeline_config_subgrid_size_16, dask_client
):
    pipeline_config_subgrid_size_16.gridder_info = replace(
        pipeline_config_subgrid_size_16.gridder_info,
        pixel_scale=2.7408653691942517e-07,
        image_scale=0.0002806646138054914,
        image_scale_padded=0.0002806646138054914,
        w_step=25389531,
    )
    gridding_manager = Gridder(pipeline_config_subgrid_size_16)
    vis_name = pipeline_config_subgrid_size_16.processing_set_info.vis_name
    subgrid_size = pipeline_config_subgrid_size_16.swiftly_info.subgrid_size
    dataset = xarray_dataset_single_time_frequency_two_polarizations
    time_count, baseline_count, channel_count, _ = dataset[vis_name].shape
    visibilities = _compute_stokes_i(dataset, vis_name)
    visibilities = visibilities.astype(np.complex128)
    visibilities = visibilities.reshape(time_count * baseline_count, channel_count)
    min_frequency = dataset.frequency.min().values

    start_channels = np.array(
        [
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
        ],
        dtype=np.int32,
    )
    end_channels = np.array(
        [
            1,
            0,
            0,
            0,
            1,
            1,
            1,
            0,
            1,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            1,
            0,
            0,
            0,
            1,
            0,
            1,
            1,
            0,
            0,
            1,
            1,
            1,
            1,
            0,
            0,
            0,
            0,
            0,
            1,
            0,
            1,
            0,
            0,
            1,
        ],
        dtype=np.int32,
    )
    uvw = np.array(
        [
            [-3.302488147e03, -4.552217596e03, 2.283030252e03],
            [-2.438011939e03, -1.012212842e04, 2.723711141e03],
            [-3.074493078e03, -8.509491879e03, 2.782799130e03],
            [2.784462542e03, -2.334635517e04, 2.244192705e03],
            [-5.593144618e03, -5.475958475e03, 3.531520225e03],
            [-4.005611873e03, -6.149651800e03, 2.869778487e03],
            [2.279950696e02, -3.957274282e03, 4.997688782e02],
            [-1.627541385e04, 1.697545533e03, 7.565273720e03],
            [-6.007014570e02, -8.290654500e02, 4.178524994e02],
            [-2.817927140e04, -9.455299311e03, 1.507001674e04],
            [-6.502625952e03, -8.953365680e03, 4.470762178e03],
            [-1.403639834e04, -1.199086213e04, 8.554072382e03],
            [-6.806308705e03, -1.928970164e04, 6.208091469e03],
            [-1.076696760e04, -1.260094900e04, 7.092054378e03],
            [1.704633151e00, 6.767494050e03, -1.048924667e03],
            [2.230386903e04, -1.219293311e04, -8.948332770e03],
            [1.899983655e04, -3.819343019e03, -8.639704099e03],
            [-2.841570020e03, 1.829699626e04, -1.451370368e03],
            [-8.545590853e03, 1.491735137e04, 1.810101580e03],
            [-3.145252773e03, 7.960660299e03, 2.859589219e02],
            [-2.109066905e04, 1.727069934e04, 7.486705578e03],
            [-1.256612857e04, 1.566932037e04, 3.616856402e03],
            [1.113865742e04, 6.259337827e02, -5.457016785e03],
            [-8.562732997e03, -7.317687220e03, 5.231878212e03],
            [-2.110781120e04, -4.964339246e03, 1.090848221e04],
            [1.728657328e03, 2.379183898e03, -1.186115304e03],
            [-1.398286067e04, -9.066515733e01, 6.753111217e03],
            [8.038215827e02, -8.810076735e03, 9.727708428e02],
            [5.694873828e03, 7.843485454e03, -3.921080015e03],
            [3.271297821e03, 3.834022286e03, -2.171719237e03],
            [-1.181906718e04, 2.217097905e03, 5.345950427e03],
            [-2.432723012e03, 4.543773993e02, 1.089752712e03],
            [2.435317579e03, -6.165584319e03, -2.228748884e02],
            [-5.942289581e03, 1.170481237e04, 1.064452632e03],
            [-1.334467490e04, 5.064192347e03, 5.645098560e03],
            [2.372913687e03, -6.013750012e03, -2.216493144e02],
            [1.442007355e03, -3.655219230e03, -1.352418139e02],
            [-8.286965266e02, 3.128208832e03, -8.191637880e01],
            [-5.704020832e03, -3.379644887e03, 3.261471948e03],
            [-1.824909903e04, -1.026296912e03, 8.938075946e03],
            [7.556592612e03, -1.420572068e03, -3.434359460e03],
            [1.967773450e04, 7.934150612e03, -1.067419123e04],
            [-1.254507820e04, 2.353347974e03, 5.676603998e03],
            [-3.304032482e03, 8.373590091e03, 3.086286711e02],
            [4.856963489e03, -1.283780200e03, -2.123759743e03],
            [1.613389416e04, 1.487479940e04, -9.985909653e03],
            [-2.190786161e03, 4.098205628e02, 9.849165667e02],
            [4.891052245e03, 1.665356219e04, -4.893850858e03],
            [1.567471240e04, -2.526610983e03, -7.147421221e03],
            [4.012752277e03, 5.520076720e03, -2.746077881e03],
        ]
    )
    channel_width = 2000000  # 1171875.0 is correct
    subgrid_u_offset = 0
    subgrid_v_offset = 0
    subgrid_config = SubgridConfig(subgrid_u_offset, subgrid_v_offset, size=subgrid_size)
    mask = end_channels > start_channels
    visibility_bin = VisibilityBin(
        subgrid_config=subgrid_config,
        vis_data=da.from_array(visibilities[mask]),
        uvw_data=uvw[mask],
        channel_count=channel_count,
        start_channels=start_channels[mask],
        end_channels=end_channels[mask],
    )

    expected_image_from_subgrid = np.array(
        [
            [
                -9.7113535015816606e-09 - 5.7622662077879945e-08j,
                2.5422776362381272e-08 + 3.3918795751725116e-08j,
                -3.2333960395779238e-07 + 3.6661427842751143e-08j,
                2.0442782771613877e-07 - 1.7704353738601242e-06j,
                8.8894688472507255e-06 + 1.1548078865386557e-07j,
                7.1061930508875548e-06 + 4.0144903639571794e-05j,
                -8.6987291989970572e-05 + 1.5501374351245545e-04j,
                -2.7630038197656859e-04 + 2.9986965318329339e-04j,
                -3.5402026988862190e-04 + 3.6101447690128907e-04j,
                -2.0250591299486587e-04 + 2.8220892097152728e-04j,
                -1.8729552950347284e-05 + 1.2952718718395317e-04j,
                2.8481825512183256e-05 + 2.0487429931659307e-05j,
                6.8327141522495083e-06 - 6.5644626212335577e-06j,
                -1.5516649142822969e-06 - 1.4560314921946427e-06j,
                -1.2725088297470787e-07 + 3.8641811327035785e-07j,
                6.4857043226024952e-08 - 4.6477016621155470e-08j,
            ],
            [
                5.9159026754906701e-08 - 3.7719054154895597e-08j,
                -1.7044356658219365e-07 + 1.0833490817761294e-07j,
                3.8859300750294923e-08 - 1.1774109130203991e-06j,
                7.9715653089826310e-06 + 1.6430012791529558e-06j,
                -9.7309325818861758e-06 + 3.7140612807573525e-05j,
                -1.5591539062975723e-04 + 5.2105589524842344e-05j,
                -3.6919742050400828e-04 - 1.6054952548927304e-04j,
                -4.2336281777366480e-04 - 5.9495897126282671e-04j,
                -3.7895714886104770e-04 - 8.3298558556066382e-04j,
                -4.0063252084010514e-04 - 6.1314255773226023e-04j,
                -3.4284853250454717e-04 - 2.0345515710751272e-04j,
                -1.4624941558594173e-04 + 2.2166009321811231e-05j,
                -1.0402317327629085e-05 + 3.2802316750332738e-05j,
                7.3990812828640673e-06 + 2.3718158862241767e-06j,
                -8.3409322158692952e-08 - 1.3022876799977795e-06j,
                -1.6180095857289091e-07 + 1.4202183185973820e-07j,
            ],
            [
                -2.3075491126941746e-07 + 2.8580294361686706e-07j,
                5.1092064833345484e-07 - 1.0017612266130613e-06j,
                3.4963938676398597e-06 + 6.6098474545053104e-06j,
                -5.6697372973894475e-05 + 8.3453402189709314e-06j,
                -1.6498756994526298e-05 - 2.6412598625202843e-04j,
                1.2101806975924889e-03 - 8.2577203127520704e-04j,
                4.0990452778735254e-03 - 3.1705651089009024e-04j,
                6.6767807038417004e-03 + 1.9786279883149405e-03j,
                7.2536427800997672e-03 + 3.5820097333960632e-03j,
                6.0299432956938404e-03 + 2.3893549313651619e-03j,
                3.4941174815710241e-03 + 1.9684163341882055e-04j,
                9.9505146918266174e-04 - 5.7924271822584750e-04j,
                -3.2984116440329392e-05 - 2.3511247783045142e-04j,
                -5.0451275734294740e-05 + 7.3022410662934925e-06j,
                4.9263585017733386e-06 + 6.8538254596869561e-06j,
                1.9622532642040076e-07 - 1.3081225421242835e-06j,
            ],
            [
                -5.7049460216885897e-07 - 1.7375040633815467e-06j,
                3.1500880643607713e-06 + 5.6422422727367687e-06j,
                -4.8627775173826042e-05 - 1.3466018265853412e-05j,
                2.6296967659688447e-04 - 2.2623170257354656e-04j,
                1.2866104829793445e-03 + 1.0817460433620932e-03j,
                -4.7538655583809764e-03 + 8.1974659493083690e-03j,
                -3.0020419681512145e-02 + 1.7517297065695381e-02j,
                -6.3743296163202956e-02 + 1.7941195312756619e-02j,
                -7.6658378792027193e-02 + 1.2904147636977115e-02j,
                -5.7840615158742281e-02 + 1.3197861005048495e-02j,
                -2.4759231095265122e-02 + 1.3279471658864894e-02j,
                -3.0370567945902094e-03 + 6.8191750268234430e-03j,
                1.3260533959066831e-03 + 9.3250405602535863e-04j,
                1.7595924817296292e-04 - 2.4430357133455906e-04j,
                -5.2174335755126927e-05 - 3.8173851767154274e-06j,
                6.0163666411887411e-06 + 5.3412911195027603e-06j,
            ],
            [
                8.9917096024332596e-06 - 9.1643765670983610e-07j,
                -3.7354453118070756e-05 + 2.6265444136478009e-06j,
                1.9391038430032620e-04 - 1.7357586407454849e-04j,
                5.6668824914458439e-04 + 1.4972377236385113e-03j,
                -1.2558023288793102e-02 + 3.6536512023091910e-03j,
                -2.7884935083677564e-02 - 3.8586315800456517e-02j,
                7.2033498434082688e-02 - 1.9391959640007705e-01j,
                3.1295381520810395e-01 - 4.0256588945032945e-01j,
                4.2945049643908817e-01 - 4.8197919613762252e-01j,
                2.6097938203707827e-01 - 3.6411595618657699e-01j,
                3.6729327898927799e-02 - 1.6507376011127395e-01j,
                -3.1087945622720270e-02 - 3.0656821150431002e-02j,
                -9.3822010170163742e-03 + 4.6213362529910484e-03j,
                1.0996207302919354e-03 + 1.2793504207170361e-03j,
                8.1876270371973169e-05 - 2.4975461206438749e-04j,
                -3.1394234546778827e-05 + 2.3955791547873671e-05j,
            ],
            [
                4.8861033029264279e-06 + 2.7043466539654628e-05j,
                -4.1628804731226645e-05 - 1.4276409675867863e-04j,
                1.0352680397103494e-03 + 7.2720324785167803e-04j,
                -9.5053116357919909e-03 + 2.6075433638951115e-03j,
                -5.1655316984152988e-03 - 5.2400342366568278e-02j,
                3.7294068996695395e-01 - 1.7031511336268901e-01j,
                1.3682416885447504e00 + 8.7075507987498746e-02j,
                2.1848827173086178e00 + 9.9987465937475051e-01j,
                2.2388583106617936e00 + 1.5814786533068990e00j,
                1.8319300089100139e00 + 9.6146850830106700e-01j,
                1.0266050495760228e00 + 4.8139745827509461e-02j,
                2.3356973312324292e-01 - 1.7532139113508610e-01j,
                -2.3501477888803621e-02 - 4.1549077727915572e-02j,
                -6.2827689713920425e-03 + 5.5785621183909121e-03j,
                1.2788458831796098e-03 + 1.5337620851065350e-04j,
                -1.3640067537929780e-04 - 9.7894613259761801e-05j,
            ],
            [
                -9.7467660422359222e-05 + 4.6335141385887016e-05j,
                3.8259152232733129e-04 - 3.2320194432883264e-04j,
                -6.9080074684019612e-04 + 4.0708356191976524e-03j,
                -2.5419966069453681e-02 - 2.4018512250555065e-02j,
                2.3417764819316567e-01 - 1.1934744502695713e-01j,
                1.1567599629239120e00 + 1.2016265307202016e00j,
                -3.8501608429435441e-01 + 7.6816352669892076e00j,
                -7.5317488460763258e00 + 1.8371612768284081e01j,
                -1.1924521442046796e01 + 2.3226487127459528e01j,
                -6.2276325588270023e00 + 1.6382253324619608e01j,
                4.1550038990780247e-01 + 5.8252043113241463e00j,
                1.1194028329661871e00 + 5.2474283661160448e-01j,
                1.1865746613125178e-01 - 1.7203271593994746e-01j,
                -3.1380831872115753e-02 - 5.8123295887969476e-03j,
                2.3327694160943969e-03 + 3.5232250412790839e-03j,
                -2.0705667624193612e-05 - 4.9447584398827941e-04j,
            ],
            [
                -2.7638820988472226e-04 - 2.2803869365411039e-05j,
                1.2280227179653769e-03 - 9.3623543960724142e-05j,
                -7.7552826058372108e-03 + 6.9691854398248191e-03j,
                -8.1014213046239052e-03 - 8.8284509078508960e-02j,
                6.9342770692213807e-01 + 1.0468420736604755e-01j,
                2.1868270226079323e-01 + 6.0133311118812305e00j,
                -1.4625083329649016e01 + 2.7902437933457922e01j,
                -4.8033386483424998e01 + 6.0307913387575582e01j,
                -6.3974355097592159e01 + 7.3761291782729984e01j,
                -3.8681517490232451e01 + 5.3007309151712278e01j,
                -7.3628498747794815e00 + 2.0897624068872517e01j,
                1.7687009306328256e00 + 3.2428572595754850e00j,
                4.8623440155740782e-01 - 2.4664277539537871e-01j,
                -5.6084401998414468e-02 - 4.6782384333741558e-02j,
                6.6894957663827669e-04 + 9.0108868935808092e-03j,
                4.8922656872703383e-04 - 8.9790829322856198e-04j,
            ],
            [
                -3.5932424943123619e-04 - 1.0713831003192540e-04j,
                1.7760382567706011e-03 + 3.2862139341514407e-04j,
                -1.4092038412326259e-02 + 7.0059083461822286e-03j,
                2.9256095695022848e-02 - 1.3531617307069677e-01j,
                9.4917594460839605e-01 + 4.4764547463741061e-01j,
                -1.8505618980345795e00 + 1.0337588388992039e01j,
                -2.9392315455874694e01 + 4.4221283905174175e01j,
                -8.3793139126332420e01 + 9.2605874010253217e01j,
                -1.0683521204879435e02 + 1.1193419270549614e02j,
                -6.5160067424233773e01 + 8.0656116505983761e01j,
                -1.4543819913182233e01 + 3.2539692929063378e01j,
                1.7090399373115885e00 + 5.5517706722643663e00j,
                7.1283213055201222e-01 - 2.2343886772693503e-01j,
                -6.2195279842231346e-02 - 7.7163851979767037e-02j,
                -1.2686495750363692e-03 + 1.1894421341448393e-02j,
                8.3230225203630203e-04 - 1.0288358145423477e-03j,
            ],
            [
                -2.7428220502506923e-04 - 7.5218666256473125e-05j,
                1.5700837330636023e-03 + 2.3672702572595511e-04j,
                -1.2199427556993422e-02 + 6.4120006637421048e-03j,
                2.3338153577596429e-02 - 1.1548985954645795e-01j,
                7.8318868379165885e-01 + 3.3275834211811317e-01j,
                -1.3447343743493012e00 + 8.3906562308119668e00j,
                -2.2370193343547555e01 + 3.6168910072183976e01j,
                -6.2797079032518241e01 + 7.5881332641632312e01j,
                -7.8248269329920362e01 + 9.1481215408807117e01j,
                -4.6045586727993566e01 + 6.5301387170069546e01j,
                -9.2957872465765981e00 + 2.5791167191127577e01j,
                1.5730285019076171e00 + 4.1641487872055674e00j,
                5.0151929253884864e-01 - 2.2394125318162472e-01j,
                -5.3025638774357550e-02 - 5.5406188898129732e-02j,
                6.1471070053404329e-05 + 9.5259690110993094e-03j,
                5.3485201125648071e-04 - 8.9299623678616540e-04j,
            ],
            [
                -1.2260239742523232e-04 + 1.0039541687617924e-05j,
                8.3806092766904603e-04 - 1.6227889811406532e-04j,
                -4.8674118074335665e-03 + 5.0796325243553323e-03j,
                -8.1961650279208497e-03 - 5.3197003462407452e-02j,
                3.7813509039854409e-01 - 1.0014346899779356e-02j,
                3.9890100982110599e-01 + 3.0409598110432694e00j,
                -5.3517285716232390e00 + 1.4738153900906966e01j,
                -1.7547701563355979e01 + 3.2117672381759853e01j,
                -2.1557426973745343e01 + 3.8858469351575380e01j,
                -1.0904996732743903e01 + 2.6939708562734282e01j,
                -6.1979738438964693e-01 + 9.7881954716985966e00j,
                1.0760328018957415e00 + 1.1733838025306087e00j,
                1.3864630261490341e-01 - 1.7893361047878378e-01j,
                -3.0266573884495072e-02 - 1.2688729213994682e-02j,
                1.8127237163168494e-03 + 4.1958453449704594e-03j,
                4.0335134468942247e-05 - 5.2026228011206339e-04j,
            ],
            [
                -2.0194747593006903e-05 + 3.0314715488881756e-05j,
                1.8052540741574248e-04 - 2.2757569416636525e-04j,
                -6.4130709176117053e-05 + 2.1410127841614479e-03j,
                -1.2665200674665839e-02 - 7.7446144493530326e-03j,
                6.5656467209503355e-02 - 8.1228338906562281e-02j,
                4.9485115483280540e-01 + 2.0473177832094092e-01j,
                9.5578759019852289e-01 + 2.0881469036627864e00j,
                9.3781919268947789e-01 + 5.2827774348187528e00j,
                1.1126230206486678e00 + 6.4793441077374361e00j,
                1.5340800831233352e00 + 4.0709510474932440e00j,
                1.1189776647548477e00 + 1.0411898030735613e00j,
                2.9046883171430415e-01 - 8.4792376855195084e-02j,
                -1.6624430816650652e-02 - 6.0070858128529241e-02j,
                -7.1021298872556860e-03 + 4.4681818501521187e-03j,
                1.1869619499619156e-03 + 4.8034450404355457e-04j,
                -1.0950871733217658e-04 - 1.3058604199925696e-04j,
            ],
            [
                6.2257981228937861e-06 + 7.9978385016975610e-06j,
                -3.3863219665386925e-05 - 6.0695559459339872e-05j,
                4.5691483261609076e-04 + 1.5363407428017721e-04j,
                -2.3297530275693864e-03 + 2.2874248491439155e-03j,
                -1.2738622028999919e-02 - 1.3828768687545748e-02j,
                4.1461220666801968e-02 - 9.4729557375397400e-02j,
                3.0970116854984475e-01 - 2.1220407336412173e-01j,
                7.1915674457859780e-01 - 2.8117217902256186e-01j,
                8.5963354377727796e-01 - 3.1677329631914120e-01j,
                5.4013764357179639e-01 - 3.1665747588334980e-01j,
                1.3292901906024479e-01 - 2.0547036142027775e-01j,
                -1.9967690612708922e-02 - 5.9023563682689462e-02j,
                -1.0943405108061181e-02 + 8.4516942248591409e-04j,
                7.8592998949089839e-04 + 1.8329396678915255e-03j,
                1.3154046017690844e-04 - 2.3811422956612326e-04j,
                -3.3846605519311044e-05 + 1.5294321034963702e-05j,
            ],
            [
                1.7592995554764065e-06 - 1.2325293867748015e-06j,
                -1.1783512177019497e-05 + 7.1957869488458110e-06j,
                1.9286674977415409e-05 - 8.7432228422664165e-05j,
                4.8313935444049827e-04 + 2.9492174339549541e-04j,
                -1.6457297499210821e-03 + 2.8189760968359429e-03j,
                -1.5291378440584702e-02 + 9.6853377246697292e-04j,
                -4.0316727430186994e-02 - 2.2939799525569349e-02j,
                -6.2890606936775839e-02 - 6.3664658606757740e-02j,
                -7.3873801825580898e-02 - 7.7091161917987705e-02j,
                -6.4483677283313057e-02 - 4.3574655303068255e-02j,
                -3.3703441435346537e-02 - 4.5140513598274090e-03j,
                -6.6693672467315057e-03 + 6.0690044222799222e-03j,
                9.5249608215257353e-04 + 1.7597571759244215e-03j,
                2.4670654491372283e-04 - 1.8505556038734584e-04j,
                -4.7135233065379077e-05 - 2.2717463954259024e-05j,
                3.6739028148470820e-06 + 7.0519927367368072e-06j,
            ],
            [
                -3.0184497927693998e-07 - 1.6268003010001334e-07j,
                2.0543535046843239e-06 + 1.2466974992380762e-06j,
                -1.4353598482045541e-05 + 4.8999965955804151e-06j,
                -6.1882987505406523e-06 - 8.8899714765045684e-05j,
                4.8676351925776296e-04 - 1.0868440218227832e-04j,
                1.5410100630257606e-03 + 1.3152269860087218e-03j,
                1.4950609078998589e-03 + 5.5123536336356693e-03j,
                -1.3575019436196101e-04 + 1.0721081450009606e-02j,
                -1.5498357944121466e-04 + 1.2618948689377518e-02j,
                2.1967288216568903e-03 + 9.0622066930627909e-03j,
                2.9639369599949728e-03 + 3.2950271817764332e-03j,
                1.3135509782195021e-03 + 6.7066567267182187e-05j,
                8.3695863192810582e-05 - 2.7034483051990854e-04j,
                -4.9988677894140937e-05 - 1.6193340452402664e-05j,
                2.1674318084251385e-06 + 8.6066109973009092e-06j,
                5.6861384769564093e-07 - 1.0911389846218192e-06j,
            ],
            [
                1.1984420856636473e-08 + 5.5380237084642014e-08j,
                -1.3545512153297426e-07 - 3.5966397748017642e-07j,
                2.2687792936952611e-06 + 6.5472744481109152e-07j,
                -6.0819835335668843e-06 + 1.1755647521122237e-05j,
                -6.7283911936777407e-05 - 1.5860646243419374e-05j,
                -1.0535607440986805e-04 - 2.3365552472531803e-04j,
                1.3541307095277233e-04 - 6.8765113440960590e-04j,
                6.0662601242000846e-04 - 1.1590302203643432e-03j,
                7.2244852923830649e-04 - 1.3512877409027624e-03j,
                2.6352716417932243e-04 - 1.0872089072471169e-03j,
                -1.5930772793204540e-04 - 5.1278748616390146e-04j,
                -1.5830371007452548e-04 - 7.7386396765799503e-05j,
                -2.8094917537940800e-05 + 2.8190643582115538e-05j,
                5.7482594449514979e-06 + 5.8487543339487413e-06j,
                3.9132565875802045e-07 - 1.2697397836717444e-06j,
                -1.7708073989932630e-07 + 8.0314984875922736e-08j,
            ],
        ]
    )

    # Act
    image_from_subgrid = gridding_manager._gridding_task_visibilities(
        visibility_bin,
        subgrid_size,
        min_frequency,
        channel_width,
    )
    # Assert
    np.testing.assert_array_almost_equal(image_from_subgrid, expected_image_from_subgrid)
    assert image_from_subgrid.shape == (16, 16)


def test_swiftly_backward_gridding(config_file_odd_facets: Callable, dask_client):
    pipeline_config = PipelineConfig(config_file_odd_facets())
    pipeline_config, processing_set_manager, swiftly_manager, gridding_manager = setup_pipeline(pipeline_config)
    visibility_bins, binning_info = bin_data(processing_set_manager, dask_client)
    swiftly_manager = grid_visibilities(visibility_bins, binning_info, swiftly_manager, gridding_manager)
    dirty_image_facets = swiftly_manager.create_facets()
    assert isinstance(dirty_image_facets[0], np.ndarray)
    assert len(dirty_image_facets) == 4


def test_swiftly_forward_degridding(config_file_odd_facets: Callable, dask_client):
    pipeline_config = PipelineConfig(config_file_odd_facets())
    pipeline_config, processing_set_manager, swiftly_manager, gridding_manager = setup_pipeline(pipeline_config)
    visibility_bins, binning_info = bin_data(processing_set_manager, dask_client)
    swiftly_manager = grid_visibilities(visibility_bins, binning_info, swiftly_manager, gridding_manager)

    model_facets = [np.ones((352, 352), dtype=np.complex128)] * 4
    assert isinstance(model_facets[0], np.ndarray)
    num_bins_before_degridding = len(visibility_bins)
    sum_res_vis_before_subtraction = np.sum(
        [np.sum(visibility_bin.res_vis.real.compute()) for visibility_bin in visibility_bins]
    )
    visibility_bins_after_subtraction = predict_residual_visibilities(
        facets=model_facets,
        visibility_bins_list=visibility_bins,
        binning_info=binning_info,
        swiftly_manager=swiftly_manager,
        gridding_manager=gridding_manager,
        normalisation_factor=1,
    )
    sum_res_vis_after_subtraction = np.sum(
        [np.sum(visibility_bin.res_vis.real.compute()) for visibility_bin in visibility_bins_after_subtraction]
    )

    assert sum_res_vis_after_subtraction != sum_res_vis_before_subtraction
    assert sum_res_vis_after_subtraction < sum_res_vis_before_subtraction
    assert not np.isnan(sum_res_vis_after_subtraction)
    assert len(visibility_bins) == num_bins_before_degridding


def test_degridding_task(gridding_manager, dask_client):
    min_frequency = 138560000.0
    subgrid_image = np.array(
        [
            [
                2.02407404e-08 - 2.42070901e-08j,
                8.15605892e-09 - 1.31493854e-08j,
                -3.09306190e-08 + 6.12355059e-08j,
                -1.01487265e-07 - 9.67754844e-08j,
                9.85196667e-08 - 2.70983088e-07j,
                -1.38490196e-05 + 1.47026926e-05j,
                -8.26286632e-05 + 7.86887301e-05j,
                -1.92121267e-04 + 1.77988653e-04j,
                -2.25547700e-04 + 2.17804470e-04j,
                -1.38466150e-04 + 1.51158854e-04j,
                -3.95222615e-05 + 5.59762348e-05j,
                -2.80145253e-06 + 8.25679280e-06j,
                2.05865528e-07 - 2.75716785e-07j,
                -7.84313697e-08 + 1.00333696e-08j,
                6.02095601e-09 + 2.93719764e-08j,
                1.07441185e-08 - 1.79656598e-08j,
            ],
            [
                1.26059342e-08 - 1.77319666e-08j,
                -3.22349699e-08 + 2.83278687e-08j,
                4.12751757e-08 - 1.10857960e-07j,
                1.63603127e-06 - 5.95871188e-07j,
                -6.48634302e-06 + 4.68616298e-06j,
                -3.55633570e-05 + 1.20760298e-05j,
                -2.70185795e-05 - 2.58761777e-05j,
                5.42288069e-05 - 1.20693696e-04j,
                9.10734325e-05 - 1.64316027e-04j,
                2.86625464e-05 - 9.78649019e-05j,
                -2.06010247e-05 - 1.78884162e-05j,
                -1.23887993e-05 + 5.36927899e-06j,
                1.06802253e-07 + 1.61398998e-06j,
                5.07070436e-07 - 2.53528005e-07j,
                -6.94608194e-08 - 2.16432370e-08j,
                8.64406923e-09 + 3.65929006e-09j,
            ],
            [
                -1.84256427e-08 + 4.53728746e-08j,
                7.99961211e-08 - 1.70159593e-07j,
                4.72299283e-07 + 5.89316058e-07j,
                -1.54388844e-05 + 7.01074876e-06j,
                5.02217493e-05 - 5.26049353e-05j,
                4.96811651e-04 - 3.35256782e-04j,
                1.10994734e-03 - 7.24430671e-04j,
                1.23104237e-03 - 8.78875109e-04j,
                1.02676497e-03 - 8.25624632e-04j,
                8.65484978e-04 - 7.08976115e-04j,
                5.33681403e-04 - 4.53489523e-04j,
                1.43459009e-04 - 1.60534543e-04j,
                -3.86190930e-06 - 1.86533885e-05j,
                -3.64598254e-06 + 2.84702181e-06j,
                5.25603077e-07 + 1.59072121e-07j,
                -6.01066309e-08 - 5.44510256e-08j,
            ],
            [
                -1.51544426e-07 - 1.69326964e-08j,
                1.13958601e-06 + 3.77821683e-07j,
                -1.33312415e-05 + 2.63475645e-06j,
                1.14376470e-04 - 7.80995379e-05j,
                6.91895997e-05 + 2.13724301e-04j,
                -3.77775836e-03 + 3.12841287e-03j,
                -1.30825336e-02 + 9.70900843e-03j,
                -1.99089206e-02 + 1.57424469e-02j,
                -1.85563200e-02 + 1.63606677e-02j,
                -1.23455886e-02 + 1.17288451e-02j,
                -5.31752865e-03 + 5.60136804e-03j,
                -8.85040202e-04 + 1.48682033e-03j,
                1.17388469e-04 + 8.77254575e-05j,
                1.44913259e-05 - 3.24247084e-05j,
                -3.56072084e-06 + 1.35734856e-06j,
                4.52574989e-07 + 9.03023136e-08j,
            ],
            [
                6.16615789e-07 - 1.35336118e-06j,
                -9.23094797e-06 + 6.90081656e-06j,
                6.70717416e-05 - 6.84345681e-05j,
                -6.74621878e-05 + 4.29355260e-04j,
                -4.90801289e-03 + 2.02256431e-03j,
                5.83449206e-03 - 1.58005547e-02j,
                9.47014999e-02 - 9.61783207e-02j,
                2.26055203e-01 - 2.13016159e-01j,
                2.48318756e-01 - 2.48263081e-01j,
                1.42735937e-01 - 1.64936648e-01j,
                3.78417864e-02 - 6.05389707e-02j,
                3.00190397e-05 - 9.04898644e-03j,
                -1.35133877e-03 + 9.07878420e-04j,
                9.29767706e-05 + 2.06149834e-04j,
                1.03325437e-06 - 3.60081098e-05j,
                -5.22813049e-07 + 4.21702348e-06j,
            ],
            [
                -5.05354902e-06 - 4.30466088e-06j,
                -2.55357604e-05 - 2.34057017e-05j,
                3.26182619e-04 + 9.58539782e-05j,
                -3.52265828e-03 + 1.72614815e-03j,
                1.20419749e-02 - 2.46290711e-02j,
                1.91951556e-01 - 9.70902560e-02j,
                3.83739283e-01 + 3.68130696e-02j,
                2.44078694e-02 + 5.97246900e-01j,
                -4.74772753e-01 + 1.01582522e00j,
                -3.00766694e-01 + 7.01985040e-01j,
                4.38017615e-02 + 1.48116445e-01j,
                5.53460072e-02 - 4.29697042e-02j,
                1.20351940e-03 - 1.40799495e-02j,
                -9.20978790e-04 + 1.25637448e-03j,
                1.27826000e-04 - 5.94832257e-06j,
                -6.82451515e-06 + 2.17576090e-07j,
            ],
            [
                -4.32993733e-05 - 1.64630103e-05j,
                3.51993012e-05 - 1.75289563e-04j,
                -6.06288326e-05 + 1.71114273e-03j,
                -5.20951998e-03 - 8.90497570e-03j,
                9.99210377e-02 - 7.32932945e-02j,
                -3.43256300e-02 + 9.43439942e-01j,
                -3.44262239e00 + 6.49538638e00j,
                -1.13627119e01 + 1.62282339e01j,
                -1.53024362e01 + 2.07532349e01j,
                -9.57209721e00 + 1.43972533e01j,
                -2.36126528e00 + 5.00044358e00j,
                9.57241774e-03 + 5.56607920e-01j,
                3.74497182e-02 - 6.39709710e-02j,
                -3.98889763e-03 - 2.12889365e-03j,
                3.40649103e-04 + 7.77652368e-04j,
                9.08581132e-06 - 5.29315405e-05j,
            ],
            [
                -1.07934513e-04 - 4.97916079e-05j,
                1.81223864e-04 - 3.84209687e-04j,
                -1.64890491e-03 + 4.74765974e-03j,
                8.35614382e-03 - 4.42291224e-02j,
                1.50378490e-01 + 2.33923359e-02j,
                -2.20898186e00 + 5.01328991e00j,
                -1.71325864e01 + 2.65262380e01j,
                -4.45565470e01 + 6.10350676e01j,
                -5.54960571e01 + 7.56000610e01j,
                -3.48174366e01 + 5.24975410e01j,
                -9.78744277e00 + 1.91615559e01j,
                -5.84791636e-01 + 2.73235963e00j,
                1.02135004e-01 - 1.01875059e-01j,
                -5.84732629e-03 - 1.68302310e-02j,
                3.32691511e-04 + 2.59610187e-03j,
                7.01172313e-05 - 1.48460198e-04j,
            ],
            [
                -1.29966323e-04 - 7.48944336e-05j,
                2.61264978e-04 - 4.88926276e-04j,
                -2.90158653e-03 + 6.68649693e-03j,
                2.62995562e-02 - 7.46246111e-02j,
                7.63844745e-02 + 1.94926625e-01j,
                -4.70811964e00 + 8.88669175e00j,
                -2.93432651e01 + 4.41950704e01j,
                -7.10882261e01 + 9.92305318e01j,
                -8.59249530e01 + 1.21442517e02j,
                -5.37187513e01 + 8.40047835e01j,
                -1.56691015e01 + 3.08868262e01j,
                -1.24719551e00 + 4.60471368e00j,
                1.23795294e-01 - 1.07589394e-01j,
                -4.38004747e-03 - 2.91602218e-02j,
                1.64832980e-04 + 3.87779760e-03j,
                1.05173844e-04 - 2.06702549e-04j,
            ],
            [
                -8.30756683e-05 - 5.30537658e-05j,
                2.07592084e-04 - 4.39160411e-04j,
                -2.45248984e-03 + 5.68715707e-03j,
                2.38326712e-02 - 6.05466478e-02j,
                3.29860412e-02 + 1.24150991e-01j,
                -3.90899383e00 + 7.08131379e00j,
                -2.32404343e01 + 3.56734266e01j,
                -5.49987141e01 + 8.02166173e01j,
                -6.54182624e01 + 9.77601214e01j,
                -4.04175077e01 + 6.69605563e01j,
                -1.17230951e01 + 2.41535059e01j,
                -9.66626669e-01 + 3.42636873e00j,
                8.10570460e-02 - 1.16764129e-01j,
                -2.42782885e-03 - 2.05830798e-02j,
                1.17411294e-04 + 3.04166149e-03j,
                6.30146245e-05 - 1.70683268e-04j,
            ],
            [
                -2.71481857e-05 - 1.57695881e-05j,
                1.00598760e-04 - 2.60141091e-04j,
                -1.09363086e-03 + 2.79213092e-03j,
                8.07233977e-03 - 2.18888157e-02j,
                4.60461289e-02 - 3.96607332e-02j,
                -1.25795880e00 + 2.35251000e00j,
                -8.15130864e00 + 1.32499366e01j,
                -1.95727076e01 + 3.07688638e01j,
                -2.30675949e01 + 3.75982489e01j,
                -1.38496278e01 + 2.52055776e01j,
                -3.77761016e00 + 8.55506889e00j,
                -2.49256318e-01 + 9.78293445e-01j,
                2.89442532e-02 - 8.84197782e-02j,
                -1.18915205e-03 - 3.96235245e-03j,
                9.03967527e-05 + 1.11139237e-03j,
                1.30271871e-05 - 7.18825503e-05j,
            ],
            [
                -3.53796161e-06 - 2.18537443e-06j,
                2.35916932e-05 - 7.32133715e-05j,
                -1.78041643e-04 + 5.53233411e-04j,
                -1.51093420e-04 - 9.05092279e-04j,
                2.35707984e-02 - 4.36538681e-02j,
                -3.61131234e-02 + 1.14921710e-01j,
                -7.34101371e-01 + 1.44333771e00j,
                -2.04418042e00 + 3.89371439e00j,
                -2.40508070e00 + 4.86514359e00j,
                -1.28817573e00 + 3.04013321e00j,
                -2.39631632e-01 + 7.95220223e-01j,
                1.74167678e-02 - 1.55008572e-02j,
                3.95748027e-03 - 2.66666221e-02j,
                -2.70752879e-04 + 1.68214957e-03j,
                1.70812252e-05 + 3.77606593e-05j,
                8.42820883e-07 - 2.46168804e-06j,
            ],
            [
                1.34210984e-07 - 1.22687274e-06j,
                -7.29838020e-07 + 4.24795954e-07j,
                2.67800934e-05 - 5.06893339e-05j,
                -4.30238810e-04 + 9.37698114e-04j,
                1.04023219e-03 - 3.39143149e-03j,
                2.58108534e-02 - 4.78457849e-02j,
                1.01866945e-01 - 1.54789477e-01j,
                2.00857414e-01 - 2.68375202e-01j,
                2.32727984e-01 - 3.05467234e-01j,
                1.57330068e-01 - 2.37878885e-01j,
                5.44350234e-02 - 1.15136130e-01j,
                6.12711351e-03 - 2.59324800e-02j,
                -3.75972661e-04 + 2.91137407e-04j,
                1.88904765e-05 + 4.80861349e-04j,
                -6.71012084e-06 - 6.15750953e-05j,
                1.04530299e-06 + 6.74201437e-06j,
            ],
            [
                6.62003756e-08 - 2.49044209e-07j,
                -7.10307579e-07 + 2.11657390e-06j,
                4.12415149e-06 - 1.26959034e-05j,
                2.00978609e-05 - 2.02398616e-05j,
                -4.44829360e-04 + 9.58118403e-04j,
                -2.17093798e-03 + 3.01201391e-03j,
                -3.20131476e-03 + 1.36662206e-04j,
                -1.57000911e-03 - 1.01350156e-02j,
                -1.44236447e-03 - 1.44368359e-02j,
                -3.78419913e-03 - 5.67324456e-03j,
                -3.33626882e-03 + 2.61849753e-03j,
                -9.23297973e-04 + 2.55650385e-03j,
                -7.13035355e-06 + 4.26936832e-04j,
                9.26451970e-07 - 5.26740319e-05j,
                -3.31617092e-07 - 4.79128606e-07j,
                8.11580077e-08 + 4.94744530e-07j,
            ],
            [
                -1.00528517e-08 + 6.10326459e-08j,
                7.02068290e-08 - 2.28693129e-07j,
                -7.75141088e-07 + 2.17830719e-06j,
                1.72239349e-06 - 7.95959719e-06j,
                5.46757303e-05 - 1.02869425e-04j,
                1.44170654e-04 - 8.10190387e-05j,
                -5.33600708e-05 + 7.75732244e-04j,
                -6.15651329e-04 + 2.36585558e-03j,
                -7.59393374e-04 + 2.95984162e-03j,
                -2.12857177e-04 + 1.75227260e-03j,
                1.66537527e-04 + 2.95540747e-04j,
                9.56370583e-05 - 1.61432984e-04j,
                4.26496645e-06 - 6.25010032e-05j,
                -8.30542975e-07 + 1.49953279e-06j,
                2.62085504e-07 + 8.57727919e-07j,
                -5.95929520e-08 - 1.46147847e-07j,
            ],
            [
                3.13683243e-09 - 5.94953238e-09j,
                -8.31093269e-09 + 2.31279836e-08j,
                9.14251455e-08 - 2.56661964e-07j,
                -3.16651901e-07 + 1.25482757e-06j,
                -6.32215736e-06 + 1.10683282e-05j,
                -1.00719803e-05 + 6.12501507e-06j,
                3.99364402e-05 - 7.95189861e-05j,
                1.48638841e-04 - 2.29815495e-04j,
                1.84873788e-04 - 2.88199746e-04j,
                9.16984183e-05 - 1.79988829e-04j,
                2.72113842e-06 - 3.88456528e-05j,
                -9.72521146e-06 + 1.33801015e-05j,
                -8.51173527e-07 + 6.92600638e-06j,
                1.77101788e-07 + 3.89111946e-08j,
                -5.25528021e-08 - 1.26974063e-07j,
                7.83841067e-09 + 2.27053827e-08j,
            ],
        ]
    )
    channel_width = 2000000  # 1171875.0 is correct
    channel_count = 1
    subgrid_size = 16
    subgrid_u_offset = 0
    subgrid_v_offset = 0
    subgrid_config = SubgridConfig(subgrid_u_offset, subgrid_v_offset, size=subgrid_size)

    visibilities = np.array(
        [
            [-0.01930282 + 0.33355892j],
            [0.05351346 - 0.13806264j],
            [0.21451677 - 0.00312339j],
            [-0.41726318 + 0.78393304j],
            [-2.30116296 - 0.35464814j],
            [-0.76112068 + 1.25617778j],
            [0.4029564 + 0.33683276j],
            [-0.15283546 + 0.78056586j],
            [-0.36911827 + 0.84281284j],
            [-0.14767398 - 0.01379245j],
            [-0.17631984 + 1.04796135j],
            [0.34144032 + 1.05318165j],
            [0.18366262 - 0.06267282j],
            [0.13196728 - 0.11532505j],
            [0.35450235 - 1.23494399j],
            [-0.24190433 - 0.02750322j],
        ]
    )
    uvw = np.array(
        [
            [-3302.488147, -4552.217596, 2283.030252],
            [-5593.144618, -5475.958475, 3531.520225],
            [-4005.611873, -6149.6518, 2869.778487],
            [227.9950696, -3957.274282, 499.7688782],
            [-600.701457, -829.06545, 417.8524994],
            [1728.657328, 2379.183898, -1186.115304],
            [3271.297821, 3834.022286, -2171.719237],
            [-2432.723012, 454.3773993, 1089.752712],
            [2435.317579, -6165.584319, -222.8748884],
            [2372.913687, -6013.750012, -221.6493144],
            [1442.007355, -3655.21923, -135.2418139],
            [-828.6965266, 3128.208832, -81.9163788],
            [-5704.020832, -3379.644887, 3261.471948],
            [4856.963489, -1283.7802, -2123.759743],
            [-2190.786161, 409.8205628, 984.9165667],
            [4012.752277, 5520.07672, -2746.077881],
        ]
    )
    start_channels = np.zeros(16, dtype=np.int32)
    end_channels = np.ones(16, dtype=np.int32)
    visibility_bin = VisibilityBin(
        subgrid_config=subgrid_config,
        vis_data=visibilities,
        uvw_data=uvw,
        channel_count=channel_count,
        start_channels=start_channels,
        end_channels=end_channels,
    )
    expected_visibilities = np.array(
        [
            [-42.50177362 + 61.34749141j],
            [-38.42476633 + 55.18252502j],
            [-40.08449208 + 57.69679746j],
            [-45.48859135 + 66.24259809j],
            [-45.89031287 + 67.20754391j],
            [-36.54311777 + 69.88296228j],
            [-41.60550365 + 62.85519039j],
            [-44.08700989 + 64.55629119j],
            [-36.27314186 + 67.17844089j],
            [-36.41059956 + 67.50679405j],
            [-37.93735514 + 71.2972305j],
            [-35.77349035 + 67.65552628j],
            [-39.70585579 + 57.15409585j],
            [-44.18134348 + 65.62847117j],
            [-44.33545306 + 64.94724619j],
            [-38.48068588 + 58.84548389j],
        ]
    )

    actual_visibilities = gridding_manager._degridding_task(
        visibility_bin, subgrid_image, channel_count, min_frequency, channel_width
    )
    print(actual_visibilities)
    assert actual_visibilities.shape == (16, 1)
    np.testing.assert_allclose(actual_visibilities, expected_visibilities, rtol=1e-4)


def test_compute_stokes_i(xarray_dataset_single_time_frequency_two_polarizations):
    dataset = xarray_dataset_single_time_frequency_two_polarizations
    expected_result = da.array(
        [
            [
                [-0.019302825 + 0.333558917j],
                [0.266637027 - 0.03425467j],
                [0.018804673 - 0.286405146j],
                [0.253863335 + 0.152649358j],
                [0.053513464 - 0.138062641j],
                [0.214516774 - 0.003123391j],
                [-0.41726318 + 0.783933043j],
                [0.257863313 + 0.015119202j],
                [-2.301162958 - 0.354648143j],
                [0.086073428 + 0.026452025j],
                [-0.180546552 - 0.126494944j],
                [0.088764392 - 0.058507305j],
                [0.004388805 + 0.069047555j],
                [0.129150748 + 0.08358296j],
                [0.559584737 + 0.045768224j],
                [0.154344276 + 0.148710519j],
                [0.073165402 - 0.049170751j],
                [0.033275753 + 0.176684573j],
                [0.075686224 - 0.205269843j],
                [0.100120656 + 0.118196592j],
                [0.226809755 + 0.055601977j],
                [0.174696013 - 0.018419899j],
                [1.605686784 + 0.922954977j],
                [0.202793837 - 0.185874492j],
                [-0.03924438 - 0.048234887j],
                [-0.761120677 + 1.256177783j],
                [-0.039016955 - 0.198100984j],
                [0.055056255 - 0.062004317j],
                [0.272586495 - 0.237862915j],
                [0.402956396 + 0.336832762j],
                [0.159074366 - 0.029217394j],
                [-0.152835459 + 0.780565858j],
                [-0.369118273 + 0.842812836j],
                [0.265288889 + 0.108425893j],
                [0.360287398 - 0.020387612j],
                [-0.147673979 - 0.013792453j],
                [-0.176319838 + 1.047961354j],
                [0.34144032 + 1.053181648j],
                [0.183662623 - 0.062672824j],
                [0.131932542 + 0.170758605j],
                [0.208299428 - 0.10620898j],
                [0.220581517 + 0.120512262j],
                [-0.033194572 + 0.062668264j],
                [0.227642477 - 0.065612525j],
                [0.131967276 - 0.115325049j],
                [0.132077619 - 0.018372569j],
                [0.35450235 - 1.234943986j],
                [0.206519604 - 0.04155134j],
                [0.00757323 + 0.007059323j],
                [-0.241904333 - 0.027503224j],
            ]
        ]
    )
    actual_result = _compute_stokes_i(dataset, "VISIBILITY_CORRECTED")
    np.testing.assert_array_almost_equal(actual_result, expected_result)


def test_compute_stokes_i_circularly_polarized(xarray_dataset_single_time_frequency_two_polarizations_circular):
    dataset = xarray_dataset_single_time_frequency_two_polarizations_circular
    expected_result = da.array(
        [
            [
                [-0.019302825 + 0.333558917j],
                [0.266637027 - 0.03425467j],
                [0.018804673 - 0.286405146j],
                [0.253863335 + 0.152649358j],
                [0.053513464 - 0.138062641j],
                [0.214516774 - 0.003123391j],
                [-0.41726318 + 0.783933043j],
                [0.257863313 + 0.015119202j],
                [-2.301162958 - 0.354648143j],
                [0.086073428 + 0.026452025j],
                [-0.180546552 - 0.126494944j],
                [0.088764392 - 0.058507305j],
                [0.004388805 + 0.069047555j],
                [0.129150748 + 0.08358296j],
                [0.559584737 + 0.045768224j],
                [0.154344276 + 0.148710519j],
                [0.073165402 - 0.049170751j],
                [0.033275753 + 0.176684573j],
                [0.075686224 - 0.205269843j],
                [0.100120656 + 0.118196592j],
                [0.226809755 + 0.055601977j],
                [0.174696013 - 0.018419899j],
                [1.605686784 + 0.922954977j],
                [0.202793837 - 0.185874492j],
                [-0.03924438 - 0.048234887j],
                [-0.761120677 + 1.256177783j],
                [-0.039016955 - 0.198100984j],
                [0.055056255 - 0.062004317j],
                [0.272586495 - 0.237862915j],
                [0.402956396 + 0.336832762j],
                [0.159074366 - 0.029217394j],
                [-0.152835459 + 0.780565858j],
                [-0.369118273 + 0.842812836j],
                [0.265288889 + 0.108425893j],
                [0.360287398 - 0.020387612j],
                [-0.147673979 - 0.013792453j],
                [-0.176319838 + 1.047961354j],
                [0.34144032 + 1.053181648j],
                [0.183662623 - 0.062672824j],
                [0.131932542 + 0.170758605j],
                [0.208299428 - 0.10620898j],
                [0.220581517 + 0.120512262j],
                [-0.033194572 + 0.062668264j],
                [0.227642477 - 0.065612525j],
                [0.131967276 - 0.115325049j],
                [0.132077619 - 0.018372569j],
                [0.35450235 - 1.234943986j],
                [0.206519604 - 0.04155134j],
                [0.00757323 + 0.007059323j],
                [-0.241904333 - 0.027503224j],
            ]
        ]
    )
    actual_result = _compute_stokes_i(dataset, "VISIBILITY_CORRECTED")
    np.testing.assert_array_almost_equal(actual_result, expected_result)


@pytest.mark.parametrize(
    "image_scale_padded, image_scale, shear_u, shear_v, window_function_fraction, expected_w_step",
    [(0.00028, 0.00028, 0, 0, None, 25510204)],
)
def test_determine_w_step(image_scale_padded, image_scale, shear_u, shear_v, window_function_fraction, expected_w_step):
    w_step = _determine_w_step(image_scale_padded, image_scale, shear_u, shear_v, window_function_fraction)
    assert round(w_step) == expected_w_step
